#N canvas 603 365 739 434 10;
#N canvas 541 408 1172 446 \$0-lua_markov_generator 0;
#X obj 20 20 cnv 15 700 400 empty empty Lua_Markov_Generator 50 30
0 20 -204786 -66577 0;
#X obj 72 268 cnv 15 600 140 empty empty empty 20 12 0 14 -257985 -66577
0;
#N canvas 0 50 450 250 (subpatch) 0;
#X array \$0-array 114 float 1;
#A 0 2 2 2 3 3 3 2 2 1 1 1 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1
1 1 1 1 1 1 1 1 2 1 1 1 0 0 0 0 0 0 1 1 1 1 1 2 2 2 2 2 2 2 2 2 2 1
1 1 1 1 1 1 1 2 2 2 2 3 3 3 2 2 1 1 1 0 0 0 1 1 1 1 1 1 1 1 1 1 1 1
1 1 1 2 1 1 1 0 0 0 0 0 0 1 1;
#X coords 0 4 113 0 600 140 1 0 0;
#X restore 72 268 graph;
#X obj 72 89 cnv 15 200 150 empty empty empty 20 12 0 14 -204800 -66577
0;
#X obj 740 277 bng 15 250 50 0 empty \$0-RmakeMarkov makeMarkovChain
17 7 0 10 -257985 -1 -1;
#X obj 740 212 tgl 15 0 empty \$0-play play 17 7 0 10 -257985 -1 -1
0 1;
#X obj 740 297 ofelia d -c21 -k \$0-markovGenerator;
#A set function ofelia.list(fv) \; math.randomseed(os.time()- os.clock()
* 1000) \; \; -- make dictionary \; \; function defaultdict(default_value_factory)
\; local t = {} \; local metatable = {} \; metatable.__index = function(t
\, key) \; if not rawget(t \, key) then \; rawset(t \, key \, default_value_factory(key))
\; end \; return rawget(t \, key) \; end \; return setmetatable(t \,
metatable) \; end \; \; -- make markov matrix \; STATE_LEN = fv[1]
\; model = defaultdict(function() return {} end) \; data = markovArray
\; datasize = #data \; data = data .. data:sub(1 \, STATE_LEN) \; for
i = 1 \, (#data - STATE_LEN) do \; state = data:sub(i \, i + STATE_LEN-1)
\; local next = data:sub(i + STATE_LEN \, i + STATE_LEN) \; model[state][next]
= (model[state][next] or 0)+1 \; end \; \; -- make tables from markov
matrix \; \; local keyTbl = {} \; local nexTbl = {} \; local prbTbl
= {} \; for key \, value in pairs(model) do \; for k \, v in pairs(value)
do \; table.insert(keyTbl \, key) \; table.insert(nexTbl \, k) \; table.insert(prbTbl
\, v) \; end \; end \; \; -- make start key \; \; local startKey =
keyTbl[1] \; state = startKey \; \; -- make table from start key \;
\; local str = state \; local stateTable = {} \; for i = 1 \, #str
do \; stateTable[i] = str:sub(i \, i) \; end \; \; out = stateTable
\; \; for i = 1 \, datasize do \; \; -- weighted random choice \; \;
local choices = {} \; local weights = {} \; for j = 1 \, #keyTbl do
\; if state == keyTbl[j] then \; table.insert(choices \, nexTbl[j])
\; table.insert(weights \, prbTbl[j]) \; end \; end \; \; local totalWeight
= 0 \; for _ \, weight in pairs(weights) do \; totalWeight = totalWeight
+ weight \; end \; rand = math.random() * totalWeight \; local choice
= nil \; for i \, weight in pairs(weights) do \; if rand < weight then
\; choice = choices[i] \; choice = choice:sub(1 \, 1) \; break \; else
\; rand = rand - weight \; end \; end \; \; -- make markov chain \;
\; table.insert(out \, choice) \; state = string.sub(state \, 2 \,
#state) .. out[#out] \; end \; \; return {table.unpack(out \, STATE_LEN
+ 1 \, #out)} \; end \;;
#X obj 947 278 nbx 5 14 1 100 0 1 empty \$0-markovOrder markovOrder
0 -8 0 10 -257985 -1 -1 15 256;
#X obj 750 318 print markov chain;
#X obj 740 339 array set \$0-array;
#X obj 740 232 metro 100;
#X obj 740 360 bng 15 250 50 0 empty \$0-sendArrayToMarkovGenerator
sendArrayToMarkovGenerator 17 7 0 10 -257985 -1 -1;
#X obj 740 379 ofelia d -c11 -k \$0-sendArrayToMarkovGenerator;
#A set function ofelia.bang() \; row = {} \; local array = pd.Array("\$0-array")
\; local s = {} \; t = array:get(0) \; for i=1 \, #t do \; s[#s+1]
= math.floor(t[i]) \; s[#s+1] = " " \; end \; s = table.concat(s) \;
s = s:gsub("%s+" \, "") \; s = string.gsub(s \, "%s+" \, "") \; markovArray
= s \; print ("array: " \, markovArray) \; end \;;
#X obj 791 171 nbx 5 14 -1e+037 1e+037 0 0 empty \$0-BPM BPM 0 -8 0
10 -257985 -1 -1 180 256;
#X obj 791 190 pow -1;
#X obj 791 211 * 30000;
#X obj 86 207 bng 15 250 50 1 \$0-sendArrayToMarkovGenerator empty
sendArrayToMarkovGenerator 17 7 0 10 -257985 -1 -1;
#X obj 86 157 bng 15 250 50 0 \$0-RmakeMarkov \$0-makeMarkov makeMarkovChain
17 7 0 10 -257985 -1 -1;
#X obj 86 137 tgl 15 0 \$0-play empty play 17 7 0 10 -257985 -1 -1
0 1;
#X obj 86 188 nbx 5 14 1 500 0 1 \$0-markovOrder empty markovOrder
0 -8 0 10 -257985 -1 -1 15 256;
#X obj 86 118 nbx 5 14 5 2000 0 1 \$0-BPM empty BPM 0 -8 0 10 -257985
-1 -1 180 256;
#X obj 740 253 s \$0-makeMarkov;
#X obj 1026 244 tabread4~ \$0-array;
#X obj 1026 197 *~ 0;
#X obj 1026 224 +~ 1;
#X obj 1026 117 phasor~ 0;
#X obj 1026 343 hip~ 5;
#X obj 1047 157 nbx 5 14 -1e+037 1e+037 0 0 empty \$0-chunkSize chunkSize
0 -8 0 10 -257985 -1 -1 45 256;
#X obj 1026 98 nbx 5 14 -1e+037 1e+037 0 0 empty \$0-frequency frequency
0 -8 0 10 -257985 -1 -1 3995 256;
#X obj 203 188 nbx 5 14 0 100 0 1 \$0-volume empty volume 0 -8 0 10
-257985 -1 -1 50 256;
#X obj 1025 379 dac~;
#X obj 1041 282 nbx 5 14 0 100 0 1 empty \$0-volume volume 0 -8 0 10
-257985 -1 -1 50 256;
#X obj 1026 322 *~;
#X obj 203 118 nbx 5 14 -1e+037 1e+037 0 1 \$0-chunkSize empty chunkSize
0 -8 0 10 -257985 -1 -1 45 256;
#X obj 203 153 nbx 5 14 -1e+037 1e+037 0 1 \$0-frequency empty frequency
0 -8 0 10 -257985 -1 -1 3995 256;
#X msg 1071 368 \; pd dsp \$1;
#X obj 1071 348 tgl 15 0 empty \$0-play play 17 7 0 10 -257985 -1 -1
0 1;
#X obj 1047 176 * 441;
#X obj 1041 302 / 100;
#X connect 4 0 6 0;
#X connect 5 0 10 0;
#X connect 6 0 9 0;
#X connect 7 0 6 1;
#X connect 10 0 21 0;
#X connect 11 0 12 0;
#X connect 13 0 14 0;
#X connect 14 0 15 0;
#X connect 15 0 10 1;
#X connect 22 0 32 0;
#X connect 23 0 24 0;
#X connect 24 0 22 0;
#X connect 25 0 23 0;
#X connect 26 0 30 0;
#X connect 26 0 30 1;
#X connect 27 0 37 0;
#X connect 28 0 25 0;
#X connect 31 0 38 0;
#X connect 32 0 26 0;
#X connect 36 0 35 0;
#X connect 37 0 23 1;
#X connect 38 0 32 1;
#X coords 0 -1 1 1 700 400 1 20 20;
#X restore 18 12 pd \$0-lua_markov_generator;
#X coords 0 434 1 433 700 400 0;
